(defun c:bl2ubl	(/ aws i eliste_tmp new_list summe summe_err drehung ip osmode_alt cmdecho_alt)

  (defun read_bl (ename / blname temp new_list)

    (setq blname  (cdr (assoc 2 (entget ename)))
	  blename
		  (tblobjname "BLOCK" blname)
	  drehung (/ (* 180 (cdr (assoc 50 (entget ename)))) pi)
    ) ;_Ende SETQ

    (setq temp blename)

    (while temp

      (setq eliste_tmp (entget temp))

      (cond
	((= "BLOCK" (cdr (assoc 0 eliste_tmp)))
	 (setq eliste_tmp
		(subst (cons 2 "*U")
		       (assoc 2 eliste_tmp)
		       eliste_tmp
		)
	 )
	)
      )

      (setq new_list (cons eliste_tmp new_list))

      (setq temp (entnext temp))

    ) ;_Ende WHILE

    (make_ubl (reverse new_list) ename)

  ) ;_Ende READ_BL

  (defun make_ubl (ubl_struct ename / nblk)

    (entmake (setq a (purge_ubl_struct (car ubl_struct))))
    
    (setq ubl_struct (cdr ubl_struct))

    (while ubl_struct
      (entmake (setq b (car ubl_struct)))
      (setq ubl_struct (cdr ubl_struct))
    ) ;_Ende WHILE

    (if	(not (setq nblk (entmake (list (cons 0 "endblk")))))
      (setq summe_err (1+ summe_err))
    )
    (princ (strcat "\nBlock "
		   (if nblk
		     nblk
		     "NOT"
		   )
		   " Made\n"
	   )
    )
    (entmake
      (list
	(cons 0 "INSERT")
	(cons 2 nblk)
	(cons 10 (cdr (assoc 10 (entget ename))))
	(cons 8 (getvar "clayer"))
      )
    )
    (entmake
      (list
	(cons 0 "SEQEND")
      )
    )
    (if	nblk
      (progn
	(entdel ename)
	(setq summe (1+ summe))
      ) ;_Ende PROGN
    )

  ) ;_Ende MAKE_UBL

  (defun purge_ubl_struct (ubl_struct / ubl_struct_new)

    (cond
      ((= (cdr (assoc 0 ubl_struct)) "BLOCK")
       (setq ubl_struct_new
	      (list (assoc 0 ubl_struct)
		    (cons 70 1)
		    (assoc 2 ubl_struct)
		    (assoc 10 ubl_struct)
	      )
       )
      )
    ) ;_Ende COND

    ubl_struct_new ;_Rckgabe

  ) ;_Ende PURGE_UBL_STRUCT
  
  (command "._undo" "_begin")
  
  (setq	aws	  (ssget '((0 . "INSERT")))
	i	  0
	summe	  0
	summe_err 0
	osmode_alt (getvar "osmode")
	cmdecho_alt (getvar "cmdecho")
  )
  
  (setvar "osmode" 0)
  (setvar "cmdecho" 0)
  
  (if aws

	  (repeat (sslength aws)

	    (setq ename	(ssname aws i)
		  i	(1+ i)
	    )
	    (read_bl ename)

	    (setq ip (cdr (assoc 10 (entget(entlast)))))
	    (command "._rotate" (entlast) "" ip drehung)
	    
	  ) ;_Ende REPEAT
	  
  );Ende IF
  
  (setvar "osmode" osmode_alt)
  (setvar "cmdecho" cmdecho_alt)

  (alert (strcat (rtos summe)
		 " anonyme Blcke erzeugt!"
		 "\n"
		 (rtos summe_err)
		 " konnten nicht ausgewertet werden!"
	 )
  )
  
  (command "._undo" "_end")

) ;_Ende bl2ubl

